public class Node<T> implements Tree<T> {
	private T value; // not null
	private Tree<T> left, right; // not null

	Node(T value, Tree<T> left, Tree<T> right) {
		assert value != null && left != null && right != null;
		this.value= value;
		this.left= left;
		this.right= right;
	}

	public T getValue() {
		return value;
	}

	public Tree<T> getLeft() {
		return left;
	}

	public Tree<T> getRight() {
		return right;
	}

	@Override
	public int size() {
		return 1 + left.size() + right.size();
	}

	@Override
	public boolean contains(T value) {
		return this.value.equals(value) || left.contains(value) || right.contains(value);
	}
}
